package de.hdm_stuttgart.battlearena.Controller.Utilities;

public enum ScreenClasses {
//    enums have a range because the screen calculations are not precise, especially with screen scaling in the OS settings
    INCH27(26, 28),
    INCH24(23, 25),
    INCH13_SURFACE(12, 14);

    final int lBound, uBound;

    ScreenClasses(int lBound, int uBound) {
        this.lBound = lBound;
        this.uBound = uBound;
    }

    public static ScreenClasses inRange(int inches) {
        for (ScreenClasses screens : ScreenClasses.values()) {
            if (screens.isInRange(inches)) {
                return screens;
            }
        }
        return null;
    }

    private boolean isInRange(int inches) {
        return inches >= lBound && inches <= uBound;
    }
}
