package de.hdm_stuttgart.battlearena.Model.DataStorage.Classes;

import de.hdm_stuttgart.battlearena.Model.DataStorage.Classes.ENUMs.AccountType;
import de.hdm_stuttgart.battlearena.Model.DataStorage.Classes.ENUMs.ThreadStatus;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class ThreadCreateAcc extends Thread{

    private static final Logger log = LogManager.getLogger(ThreadCreateAcc.class);
    private String playerName;
    private String password;
    private AccountType type;

    @Override
    public void run() {

        Persistence persistenceInst = Persistence.getInstance();
        Threads threadsInstance = Threads.getInstance();

        try {
            threadsInstance.setThreadCreateAccMsg("");
            threadsInstance.setThreadCreateAcc(ThreadStatus.RUNNING);
            persistenceInst.createAccount(playerName, password, type);
            log.info("Create account thread finished successfully!");
            threadsInstance.setThreadCreateAcc(ThreadStatus.FINISHED);
        } catch (Exception e) {
            log.error(e);
            threadsInstance.setThreadCreateAccMsg(e.getMessage());
            log.info("Create account thread failed!");
            threadsInstance.setThreadCreateAcc(ThreadStatus.FAILED);
        }
    }

    public void startThread(String playerName, String password, AccountType type){
        this.playerName = playerName;
        this.password = password;
        this.type = type;
        start();
    }

}
