package de.hdm_stuttgart.battlearena.Model.DataStorage.Classes;

import de.hdm_stuttgart.battlearena.Model.DataStorage.Classes.ENUMs.ThreadStatus;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class ThreadLogin extends Thread{

    private static final Logger log = LogManager.getLogger(ThreadLogin.class);
    private String userName;
    private String password;

    @Override
    public void run() {

        Persistence persistenceInst = Persistence.getInstance();
        Threads threadsInstance = Threads.getInstance();

        try {
            threadsInstance.setThreadLoginMsg("");
            threadsInstance.setThreadLogin(ThreadStatus.RUNNING);
            persistenceInst.login(userName, password);
            log.info("Login thread finished successfully!");
            threadsInstance.setThreadLogin(ThreadStatus.FINISHED);
        } catch (Exception e) {
            log.error(e);
            threadsInstance.setThreadLoginMsg(e.getMessage());
            log.info("Login thread failed!");
            threadsInstance.setThreadLogin(ThreadStatus.FAILED);
        }
    }

    public void startThread(String userName, String password){
        this.userName = userName;
        this.password = password;
        start();
    }

}
