package de.hdm_stuttgart.battlearena.Model.Entity;

import de.hdm_stuttgart.battlearena.Controller.GameSceneController;
import de.hdm_stuttgart.battlearena.Model.Entity.GameplayObjects.ObjectStatus;
import de.hdm_stuttgart.battlearena.Model.Entity.GameplayObjects.ObjectType;
import javafx.geometry.BoundingBox;
import javafx.scene.canvas.GraphicsContext;
import javafx.scene.image.Image;

import java.util.Objects;

public class Explosion implements IEntity {

    private final int posX;
    private final int posY;
    private Image sprite;
    private final GraphicsContext graphicsContext;
    private BoundingBox boxCollider;
    private boolean status;
    private final ObjectType OBJECT_TYPE = ObjectType.EXPLOSION;

    private final ObjectStatus OBJECT_STATUS = ObjectStatus.UNUSED;
    public Explosion(int posX, int posY, GraphicsContext graphicsContext) {
        this.posX = posX;
        this.posY = posY;
        this.graphicsContext = graphicsContext;

        initializeEntity();
    }
    @Override
    public void initializeEntity() {
        loadEntitySprites();
        boxCollider = new BoundingBox(posX+12, posY+12, 24, 24);
    }
    @Override
    public void loadEntitySprites() {
        sprite = new Image(Objects.requireNonNull(getClass().getResourceAsStream("/textures/objects/vfx/smallexplosion.png")));
    }

    @Override
    public void updateEntityMovement(GameSceneController gameScene) {

    }

    @Override
    public void checkGameplayObjectInteraction(IEntity entity, GraphicsContext graphicsContext) {

    }

    @Override
    public void placeBomb(IEntity entity, IEntity entity2, GraphicsContext graphicsContext) {

    }

    @Override
    public void attack(IEntity entity, GraphicsContext graphicsContext) {

    }

    @Override
    public void updateEntityWalkAnimation() {

    }

    @Override
    public void renderEntity(GraphicsContext graphicsContext) {
        graphicsContext.drawImage(sprite, posX, posY, 48, 48);
    }

    @Override
    public void healPlayer(int heal) {

    }

    @Override
    public BoundingBox getBoxCollider() {
        return boxCollider;
    }

    @Override
    public EntityDirection getEntityDirection() {
        return null;
    }

    @Override
    public int getEntitySpeed() {
        return 0;
    }

    @Override
    public void gotHit(int damageDone) {

    }

    @Override
    public int getMapPosX() {
        return posX;
    }

    @Override
    public int getMapPosY() {
        return posY;
    }

    public ObjectType getOBJECT_TYPE() {
        return OBJECT_TYPE;
    }

    @Override
    public ObjectStatus getOBJECT_STATUS() {
        return OBJECT_STATUS;
    }

    @Override
    public void setObjectStatus(ObjectStatus objectStatus) {

    }

}
