package de.hdm_stuttgart.battlearena.Model.Entity;

import de.hdm_stuttgart.battlearena.Controller.GameSceneController;
import de.hdm_stuttgart.battlearena.Model.Entity.GameplayObjects.ObjectStatus;
import de.hdm_stuttgart.battlearena.Model.Entity.GameplayObjects.ObjectType;
import javafx.geometry.BoundingBox;
import javafx.scene.canvas.GraphicsContext;

public interface IEntity {

    void initializeEntity();

    void loadEntitySprites();

    void updateEntityMovement(GameSceneController gameScene);

    //checks collision with GameplayObjects by iterating through GameplayObjects list
    void checkGameplayObjectInteraction(IEntity entity, GraphicsContext graphicsContext);

    void placeBomb(IEntity entity, IEntity entity2, GraphicsContext graphicsContext);

    void attack(IEntity entity, GraphicsContext graphicsContext);

    void updateEntityWalkAnimation();

    void renderEntity(GraphicsContext graphicsContext);

    void healPlayer(int heal);

    BoundingBox getBoxCollider();

    EntityDirection getEntityDirection();

    int getEntitySpeed();

    void gotHit(int damageDone);

    int getMapPosX();

    int getMapPosY();

    ObjectType getOBJECT_TYPE();

    ObjectStatus getOBJECT_STATUS();
    void setObjectStatus(ObjectStatus objectStatus);
}